import org.graphstream.algorithm.Dijkstra;
import org.graphstream.graph.Edge;
import org.graphstream.graph.Graph;
import org.graphstream.graph.Node;

import java.util.ArrayList;

public class MonDijkstra
{
	public static void Dijkstra(Graph g)
	{
		ArrayList<Node> sommets = getNodes(g);
		Node u = sommetMin(sommets);
		while (u != null)
		{
			sommets.remove(u);
			u.setAttribute("marque", true);
			ArrayList<Node> voisins = new ArrayList<>();
			u.leavingEdges().forEach(edge -> voisins.add(edge.getNode1()));

			for (Node n : voisins)
			{
				Edge e = u.getEdgeBetween(n);
				Node v = n;

				int poidsU = (int) u.getAttribute("poids");
				int poidVoisin = (int) v.getAttribute("poids");
				int distUV = (int) e.getAttribute("distance");

				if (poidVoisin > (poidsU + distUV) && !(v.hasAttribute("marque")))
				{
					v.setAttribute("poids", poidsU + distUV);
					v.setAttribute("pere", u.getId());
				}

			}
			u = sommetMin(sommets);
		}
	}

	private static ArrayList getNodes(Graph g)
	{
		ArrayList<Node> alNode= new ArrayList<>();
		for (int i = 0; i < g.getNodeCount(); i++) {
			alNode.add(g.getNode(i));

		}
		return alNode;
	}

	private static Node sommetMin (ArrayList<Node> sommets)
	{
		Node minSommet = null;
		int minval = Integer.MAX_VALUE;

		for (Node n : sommets)
		{

			if(((int)(n.getAttribute("poids")) < minval))
			{
				minval = (int) n.getAttribute("poids");
				minSommet = n;
			}

		}
		return minSommet;
	}
	public static String affichage(Graph g)
	{
		String ligne1 = "+";
		String ligne2 = "";
		String ligne3 = "";
		Node n;
		for (int i = 0; i < g.getNodeCount(); i++)
		{
			n = g.getNode(i);
			ligne1 += "------------+";
			ligne2 += String.format("| %-11s", "d(" + n + ")");
			if((int) g.getNode(i).getAttribute("poids") == Integer.MAX_VALUE)
				ligne3 += String.format("|%-11s ","infini");
			else
				ligne3 += String.format("| %-4d (%4s)",(int) n.getAttribute("poids"), (n.getAttribute("pere") != null ? n.getAttribute("pere"):""));

		}

		ligne1 +="\n";
		ligne2 +="|\n";
		ligne3 +="|\n";

		return ligne1 + ligne2 + ligne1 + ligne3 + ligne1;
	}

	public static String affichage(Graph g, Dijkstra d)
	{
		String ligne1 = "+";
		String ligne2 = "";
		String ligne3 = "";

		for (Node n: g)
		{
			ligne1 += "------------+";
			ligne2 += String.format("| %-11s", "d(" + n + ")");
			if(Double.isInfinite(((double) d.getPathLength(n))))
				ligne3 += String.format("|%-11s ","infini");
			else
				ligne3 += String.format("| %-4d (%4s)",(int) d.getPathLength(n) , (d.getParent(n)!= null ? d.getParent(n): ""));
		}

		ligne1 +="\n";
		ligne2 +="|\n";
		ligne3 +="|\n";

		return ligne1 + ligne2 + ligne1 + ligne3 + ligne1;
	}
}
